/* tmnr6d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static double x[2] = { -1.2,1. };
    static float tmax = 30.f;
    static int n = 2;
    static double xe[2] = { 1e-18,1e-18 };
    static double fe = 1e-18;
    static double a[2] = { -1.3,.5 };
    static double b[2] = { .5,1. };
    static int i0[2] = { 1,1 };
    static double rm[15] = { 100. };
    static double ge[2] = { 1e-10,1e-10 };
    static double up[4] = { 1e-15,10.,1.2,100. };

    /* Local variables */
    extern int grad_c(), func_c();
    static int ierr;
    extern int mnr6d_c(double *, double *, int *, double *, double *,
                       int *, U_fp, double *, double *, U_fp, double *,
                       double *, double *, double *, int *, float *, int *);
    static double f, g[2];
    extern int utmn05_c(float *);
    static float t0, t1, dt;
    static int irm[2];

    utmn05_c(&t0);
    printf("\n %15.6e %15.6e \n", x[0], x[1]);
    printf("\n %15.6e %15.6e \n", a[0], a[1]);
    printf("\n %15.6e %15.6e \n", b[0], b[1]);
    printf("\n %15.6e %15.6e \n", xe[0], xe[1]);
    printf("\n %15.6e \n", fe);
    printf("\n %15.6e %15.6e \n", ge[0], ge[1]);
    printf("\n %15.6e %15.6e %15.6e %15.6e \n\n", up[0], up[1], up[2], up[3]);

    mnr6d_c(x, xe, i0, a, b, &n, (U_fp)func_c, &f, &fe, (U_fp)grad_c, g, ge,
            up, rm, irm, &tmax, &ierr);

    utmn05_c(&t1);
    dt = t1 - t0;
    printf("\n %15.6e %15.6e %15.6e \n", rm[0], rm[1], rm[2]);
    printf("\n %5i \n", ierr);
    printf("\n %15.6e \n", f);
    printf("\n %15.6e %15.6e \n", x[0], x[1]);
    printf("\n %15.6e %15.6e \n", g[0], g[1]);
    printf("\n %6.2f \n", dt);
    return 0;
} /* main */

int func_c(double *x, double *f, double *fe)
{
    /* System generated locals */
    double d__1, d__2, d__3;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    d__2 = x[1];
/* Computing 2nd power */
    d__1 = x[2] - d__2 * d__2;
/* Computing 2nd power */
    d__3 = 1. - x[1];
    *f = d__1 * d__1 + d__3 * d__3;
    return 0;
} /* func_c */

int grad_c(double *x, double *g, double *ge, int *i0)
{
    /* System generated locals */
    double d__1;

    /* Parameter adjustments */
    --i0;
    --ge;
    --g;
    --x;

    /* Function Body */
    g[1] = 0.;
    if (i0[1] == 0) {
        goto L10;
    }
/* Computing 2nd power */
    d__1 = x[1];
    g[1] = (x[2] - d__1 * d__1) * -4. * x[1] - (1. - x[1]) * 2.;
L10:
    g[2] = 0.;
    if (i0[2] == 0) {
        goto L20;
    }
/* Computing 2nd power */
    d__1 = x[1];
    g[2] = (x[2] - d__1 * d__1) * 2.;
L20:
    return 0;
} /* grad_c */
